// TestView.cpp : implementation of the CTestView class
//

#include "stdafx.h"
#include "Test.h"
#include "math.h"
#include "TestDoc.h"
#include "TestView.h"
#include <iostream>
using namespace std;
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTestView

IMPLEMENT_DYNCREATE(CTestView, CScrollView)

BEGIN_MESSAGE_MAP(CTestView, CScrollView)
	//{{AFX_MSG_MAP(CTestView)
	ON_COMMAND(IDM_DIALOG, OnDialog)
	ON_COMMAND(ID_PSNR, OnPsnr)
	ON_COMMAND(ID_PSNR2, OnPsnr2)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CScrollView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestView construction/destruction

CTestView::CTestView()
{
	// TODO: add construction code here

}

CTestView::~CTestView()
{
}

BOOL CTestView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CScrollView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CTestView drawing

void CTestView::OnDraw(CDC* pDC)
{
	CTestDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here


	pDC->TextOut(80,260,"1. Riht_IMAGE",15);
	pDC->TextOut(380,260,"2. Left_IMAGE",15);
	pDC->TextOut(80,280,"3. Disparity",15);
	pDC->TextOut(380,280,"4. IVR_IMAGE",15);


	//1 ̹ 
	
	for(int y=0;y<256;y++)
	{
		for(int x=0;x<256;x++)
		{
		//	pDC->SetPixel(x,y,RGB(pDoc->m_OpenImg[y][x],
		//		                  pDoc->m_OpenImg[y][x],
		//						  pDoc->m_OpenImg[y][x]));
			pDC->SetPixel(x,y,RGB(pDoc->m_LeftImg[y][x],
				                  pDoc->m_LeftImg[y][x],
								  pDoc->m_LeftImg[y][x]));
		}
	}
//( 2 ̹)
		
	
	for(int y=0;y<256;y++)
	{
		for(int x=0;x<256;x++)
		{
			//pDC->SetPixel(x+300,y,RGB(pDoc->m_ResultImg[y][x],
			//					      pDoc->m_ResultImg[y][x],
			//						  pDoc->m_ResultImg[y][x]));
			pDC->SetPixel(x+300,y,RGB(pDoc->m_RightImg[y][x],
								      pDoc->m_RightImg[y][x],
									  pDoc->m_RightImg[y][x]));
		}
	}
	//  ȭ ..
	for(int y=0;y<256;y++)
	{
		for(int x=0;x<256;x++)
		{
			pDC->SetPixel(x,y+300,RGB(pDoc->m_Img3[y][x],
				                      pDoc->m_Img3[y][x],
									  pDoc->m_Img3[y][x]));
		}
	}
    //Saturation ȭ...
	for(int y=0;y<256;y++)
	{
		for(int x=0;x<256;x++)
		{
			pDC->SetPixel(x+300,y+300,RGB(pDoc->m_Img4[y][x],
				                          pDoc->m_Img4[y][x],
								          pDoc->m_Img4[y][x]));
		}
	}


	


	// PSNR  ˰

	
    
   /* int i,j,temp1=0,sum=0,row=255,col=255;
    double v_psnr,temp2=0;
    float rmse;
 
    for(i=0;i<row;i++)
        {
            for(j=0;j<col;j++)
            {  //temp1=pDoc->m_Img4[i][j]-pDoc->m_RightImg[i][j];
			   temp1=pDoc->m_LeftImg[i][j]-pDoc->m_Img4[i][j];
               temp1=temp1*temp1;
               sum+=temp1;
            }
        }
            temp2=sum/(row*col);
            rmse=(float)pow(temp2,0.5);

           // cout<<"rmse= "<<rmse<<endl;
	       // pDC->TextOut(400,280,"rmse is"rmse,15);

           //v_psnr=20*log10(255/rmse);

		   v_psnr=20*log10(255/rmse);

		  
        
            //cout<<"psnr= "<<v_psnr<<endl;

  CString str1;
  str1.Format("psnr : %.5f DB Դϴ.", v_psnr);
  MessageBox(str1,"PSNR",MB_OK);
 
	           

*/ 
 
 





}

void CTestView::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();

	CSize sizeTotal;
	// TODO: calculate the total size of this view


	sizeTotal.cx = sizeTotal.cy = 100;
	SetScrollSizes(MM_TEXT, sizeTotal);

	CTestDoc* pDoc=GetDocument();//ȭ ʱȭ
	for(int x=0 ;x<256 ; x++)
	{
		for(int y=0;y<256;y++)
		{
		m_ViewImg[x][y]=pDoc->m_LeftImg[x][y];
		m_ViewImg2[x][y]=pDoc->m_RightImg[x][y];
		}
	}


}

/////////////////////////////////////////////////////////////////////////////
// CTestView printing

BOOL CTestView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CTestView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CTestView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CTestView diagnostics

#ifdef _DEBUG
void CTestView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CTestView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

CTestDoc* CTestView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CTestDoc)));
	return (CTestDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CTestView message handlers







void CTestView::OnDialog() 
{

	// TODO: Add your command handler code here
	int data=0 ;//,data1=0,data2=0;
	CParaDlg dlg;
//	dlg.DoModal();
	

	if( dlg.DoModal()==IDOK )
	{
		// Էϰ ... ̹ εѴ.



	int blks=0;
	blks=dlg.m_bs;
	CTestDoc* pDoc=GetDocument(); //ťƮ Ŭ ..
    ASSERT_VALID(pDoc);
	
	pDoc->DoubleLoad(); //ε Լ ȣ!!

    Invalidate(FALSE);



	  // BMA Լ ȣ...
	 
	  int row,col,sr,bs,ex; // ddx ߿ϰ ϴ ̷Զ...
	  row=256;
	  col=256;
	  //sr=32;   //default
	  //bs=16;
	  //ex=48;

	  sr=32;
	  bs=blks;
	  ex=48;

	  
	  //dlg.m_bs=obj;
	  //bs=obj;
	 

	  /*
	  CParaDlg dlg;
	  UpdateData(TRUE);
	  sr=dlg.m_sr;
	  bs=dlg.m_bs;
	  ex=dlg.m_ex;
	  UpdateData(FALSE);
//	  int data_1,data_2
*/
	  int **temp=0;
	   
	  int **leftdata=0,**rightdata=0;
	  
	  leftdata = new int*[256];
	  rightdata = new int*[256];
	  temp =new int*[256];
	  for(int i = 0 ; i < 256 ; i++)
	  {
		  leftdata[i] = new int[256];
		  rightdata[i] = new int[256];
		  temp[i] = new int[256];
	  }

	  for( int z=0; z<256; z++)
	  {
		  for( int t=0; t<256; t++)
		  {
	            leftdata[z][t]=pDoc->m_LeftImg[z][t];
			    rightdata[z][t]=pDoc->m_RightImg[z][t];
		  }
	  }


	  pDoc->BMA(leftdata,rightdata,temp,row,col,bs,ex,sr);
  
	  
    Invalidate(FALSE);

	}


	

	
}

//DEL void CTestView::OnFBMA()
//DEL {
//DEL 	CTestDoc* pDoc = GetDocument();
//DEL 	ASSERT_VALID(pDoc);
//DEL 
//DEL 	pDoc->FBMA(leftdata,rightdata,temp,row,col,bs,ex,sr);
//DEL 
//DEL 	Invalidate(FALSE);
//DEL }

void CTestView::OnPsnr() 
{
	// TODO: Add your command handler code here
	CTestDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	int i,j,temp1=0,sum=0,row=255,col=255;

    //int data_raw=0,data_col=0;

	//CParaDlg pg;
	//pg.DoModal();
	//pg.m_ex=data_row;
	//pg.m_sr=data_col;
	//row=data_row;
	//col=data_col;

	double v_psnr,temp2=0;
    float rmse;
 
    for(i=0;i<row;i++)
        {
            for(j=0;j<col;j++)
            {  //temp1=pDoc->m_Img4[i][j]-pDoc->m_RightImg[i][j];
			   temp1=pDoc->m_LeftImg[i][j]-pDoc->m_Img4[i][j];
               temp1=temp1*temp1;
               sum+=temp1;
            }
        }
            temp2=sum/(row*col);
            rmse=(float)pow(temp2,0.5);

           // cout<<"rmse= "<<rmse<<endl;
	       // pDC->TextOut(400,280,"rmse is"rmse,15);

           //v_psnr=20*log10(255/rmse);

		   v_psnr=20*log10(255/rmse);

		  
        
            //cout<<"psnr= "<<v_psnr<<endl;

  CString str1;
  str1.Format("psnr : %.5f DB Դϴ.", v_psnr);
  MessageBox(str1,"PSNR",MB_OK);

 
	
}

void CTestView::OnPsnr2() 
{
	// TODO: Add your command handler code here
		AfxMessageBox(" ߰ ̹  ּ");

	

	CFileDialog dlg(TRUE); // ̾α ڽ ü...
	if(dlg.DoModal()==IDOK)
	{
		//⼭ о  ̹   6-8 ̹  7  IVR ̹ ϴ°̴.
		
		CFile file;
		file.Open(dlg.GetFileName(),CFile::modeRead);// ..
		file.Read(m_centerImg,sizeof(m_centerImg));//fileо..
		file.Close();
	}
     
		CTestDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	int i,j,temp1=0,sum=0,row=255,col=255;
    double v_psnr,temp2=0;
    float rmse;
 
    for(i=0;i<row;i++)
        {
            for(j=0;j<col;j++)
            {  
			   temp1=m_centerImg[i][j]-pDoc->m_Img4[i][j];
               temp1=temp1*temp1;
               sum+=temp1;
            }
        }
            temp2=sum/(row*col);
            rmse=(float)pow(temp2,0.5);

           // cout<<"rmse= "<<rmse<<endl;
	       // pDC->TextOut(400,280,"rmse is"rmse,15);

           //v_psnr=20*log10(255/rmse);

		   v_psnr=20*log10(255/rmse);

		  
        
            //cout<<"psnr= "<<v_psnr<<endl;

  CString str1;
  str1.Format("psnr : %.5f DB Դϴ.", v_psnr);
  MessageBox(str1,"PSNR",MB_OK);
 

	
}
